<?php
if (!defined('SMF'))
	die('Hacking attempt...');


if (!function_exists('to_query_string'))
{
	function to_query_string($arr)
	{
		$res = "";
		if (list($key, $val) = each($arr))
		{
			$key = urlencode($key);
			$val = urlencode($val);
			$res = "$key=$val";
			while (list($key, $val) = each($arr))
			{
				$key = urlencode($key);
				$val = urlencode($val);
				$res .= "&"."$key=$val";
			}
		}
		return $res;
	}
}

// Аналог функции file_put_contents() из PHP5 для PHP4
if (!function_exists('file_put_contents'))
{
	function file_put_contents($file_name, $content)
	{
		$f = fopen($file_name, 'wb'); // Создаём новый файл для записи в бинарном режиме
		flock($f, LOCK_EX);           // Блокируем файл исключительной блокировкой
		fwrite($f, $content);         // Записываем в файл контент
		fflush($f);                   // Сброс буферизованных данных в файл
		flock($f, LOCK_UN);           // Разблокируем файл
		fclose($f);                   // Закрываем файл
	}
}

function load_pages()
{
	global $db_prefix, $pages, $context, $txt, $smcFunc;

	$query = $smcFunc['db_query']('', "
		SELECT * FROM {db_prefix}pages
		ORDER BY `sort`"
	);

	$in_edit_mode = !empty($_REQUEST['action']) && $_REQUEST['action'] == 'admin' &&
									!empty($_REQUEST['area']) && $_REQUEST['area'] == 'pages';

	while($row = $smcFunc['db_fetch_assoc']($query))
	{
		$pages[$row['id']] = array(
			'id' 						=> $row['id'],
			'name' 					=> htmlentities($row['name']),
			'content' 			=> !$in_edit_mode ? pages_proccess_page($row['id'], $row['content'], $row['enablephp'], $row['enablebbc']) : $row['content'],
			'time' 					=> $row['time'],
			'sort' 					=> $row['sort'],
			'publicate' 		=> $row['publicate'],
			'showmenuitem'  => $row['showmenuitem'],
			'enablephp'			=> $row['enablephp'],
			'enablebbc'			=> $row['enablebbc'],
			'req_posts'			=> $row['req_posts'],
			'permissions' 	=> explode(',', $row['permissions']),
			'title' 				=> htmlentities($row['title']),
			'meta_k' 				=> htmlentities($row['meta_keywords']),
			'meta_d' 				=> htmlentities($row['meta_description'])
		);
		if ($row['showmenuitem'] && pages_check_access($row['id']))
			$context['pages_mod'][] = $row;
	}

	$smcFunc['db_free_result']($query);

	if ($in_edit_mode)
		$pages = stripslashes__recursive($pages);				// !!!
}

function pages_get_cache_filename($page_id)
{
	global $cachedir;

	return
		$cachedir . '/pages_mod-content-' . $page_id . '.php';
}

function pages_check_content($content, $php, $bbc)
{
	return false;
}

function pages_put_cache($page_id, $content, $php, $bbc)
{
	$file_id = $page_id ? $page_id : md5(uniqid(rand(), true));
	$filename = pages_get_cache_filename($file_id);
	if (file_exists($filename) && !unlink($filename)) return false;
	if (!touch($filename)) return false;
	$content = stripslashes($content);				// !!!
	file_put_contents($filename, $content);
	return
		$page_id ? $filename : array('filename' => $filename, 'hash' => $file_id);
}

function pages_proccess_page($page_id, $content, $php, $bbc)
{
	global $sourcedir;

	$filename = pages_get_cache_filename($page_id);
	if (!file_exists($filename))
		pages_put_cache($page_id, $content, $php, $bbc);
	$result = '';
	if ($php)
	{
		ob_start();
		eval('include("'.$filename.'");');
		$result = ob_get_clean();
	}
	else
		$result = file_get_contents($filename);
	if ($bbc) {
		require_once($sourcedir . '/Subs.php');
		$result = parse_bbc($result);
	}
    $result = pages_process_content($result);
	return $result;
}

function pages_check_access($page_id)
{
	global $pages, $user_info;

	$flag = false;
	if(!isset($pages[$page_id]))
		$flag = false;
	elseif (empty($pages[$page_id]['publicate']))
		$flag = false;
	elseif(in_array($user_info['groups'][0], array(1,2,3)) && in_array($user_info['groups'][0], $pages[$page_id]['permissions']))
		$flag = true;
	elseif($user_info['posts'] >= $pages[$page_id]['req_posts'] && in_array($user_info['groups'][0], $pages[$page_id]['permissions']))
		$flag = true;
	else
		$flag = false;

	return $flag;
}

function pages_process_content($content)
{
    if (!empty($content)) {
        if (strpos($content, '[flashchat]') !== false) {
            $pockets = array();
            preg_match_all('~'.preg_quote('[flashchat]', '~').'(.*)'.preg_quote('[/flashchat]', '~').'~i', $content, $pockets);
            if (!empty($pockets[1])) {
                foreach ($pockets[1] as $chat_url) {

                    $replace_search = '[flashchat]'.$chat_url.'[/flashchat]';
                    $replacement = '';

                    $chat_url = htmlspecialchars(rtrim($chat_url, '\\/'));
                    if ((string)$chat_url !== '') {
                        $replacement = '
                            <script language="JavaScript" type="text/javascript" src="'.$chat_url.'/javascript/ActivateFlash.js"></script>
                            <center>
                                <script type="text/javascript">
                                //<![CDATA[
                                    FL_RunContent(
                                        "codebase","http://fpdownload.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=7,0,0,0",
                                        "pluginspage","http://www.macromedia.com/go/getflashplayer",
                                        "name","flashchat",
                                        "id","flashchat",
                                        "width","100%",
                                        "height","800",
                                        "BASE","'.$chat_url.'/",
                                        "align","",
                                        "salign","LT",
                                        "src","'.$chat_url.'/preloader.swf",
                                        "movie","'.$chat_url.'/preloader.swf",
                                        "flashvars","",
                                        "menu","true",
                                        "scale","noscale",
                                        "quality","high"
                                    ); //end ActivsteFlash
                                //]]>
                                </script>
                                <script type="text/javascript" src="'.$chat_url.'js.php"></script>
                            </center>
                        ';
                    }

                    $content = str_replace($replace_search, $replacement, $content);
                }
            }
        }
    }
    return $content;
}
?>