<?php
// Prevert Hacking
if (!defined('SMF'))
	die('Hacking attempt...');

function Pages()
{
	global $txt, $context, $scripturl, $db_prefix, $pages_groups, $smcFunc;

	// You need to be an admin to edit settings!
	isAllowedTo('admin_forum');

	// All the admin bar, to make it right.
	loadTemplate('Pages');
	loadLanguage('Pages');

	// Delegation makes the world... that is, the package manager go 'round.
	$subActions = array(
		'main'      => 'mainPages',
		'add'       => 'addPages',
		'edit'      => 'editPages',
		'delete'    => 'deletePages',
		'public'    => 'publicPages',
		'unpublic'  => 'unpublicPages'
	);

	// By default do the basic settings.
	$_REQUEST['sa'] 				= isset($_REQUEST['sa']) && isset($subActions[$_REQUEST['sa']]) ? $_REQUEST['sa'] : 'main';
	$context['sub_action'] 	= $_REQUEST['sa'];
	// Set up some tabs...
	$context[$context['admin_menu_name']]['tab_data'] = array(
		'title'             => $txt['page_management'],
		'description'       => $txt['page_management_desc'],
		'tabs' 		        => array(
		    'main'              => array(
			    'title'             => $txt['page_management_main'],
			    'href'              => $scripturl . '?action=pgmod',
                'description'       => $txt['page_management_desc'],
		    ),
		    'add' => array(
		        'title'             => $txt['page_management_add'],
			    'href'              => $scripturl . '?action=pgmod;sa=add',
                'description'       => $txt['page_management_desc'],
		    ),
		),
	);

	if(isset($_POST['save_sort']))
	{
		if(isset($_POST['sort_pages']))
			foreach($_POST['sort_pages'] as $key => $val)
			{
				$smcFunc['db_query']('', "
					UPDATE {db_prefix}pages
					SET `sort` = {string:sort}
					WHERE `id` = {int:id}",
					array(
						'sort' => $val,
						'id'	 => (int)$key,
					)
				);
			}
		redirectexit('action=admin;area=pages;sa=main;msg=sorted');
	}


	$query = $smcFunc['db_query']('', "
		SELECT `id_group`, `group_name`
		FROM `{db_prefix}membergroups`
		WHERE `min_posts` = -1
		ORDER BY `id_group` ASC"
	);
	$pages_groups = array(
		array(
			'id' 	=> -1,
			'name' 	=> $txt['page_management_gname_unreg']
		),
		array(
			'id' 	=> 0,
			'name' 	=> $txt['page_management_gname_newreg']
		)
	);
	while($row = mysql_fetch_assoc($query))
	{
		$pages_groups[] = array(
			'id' 	=> $row['id_group'],
			'name' 	=> $row['group_name'],
		);
	}
	$smcFunc['db_free_result']($query);

	// Attempt to automatically select the right tab.
	if (isset($context['admin_tabs']['tabs'][$context['sub_action']]))
		$context['admin_tabs']['tabs'][$context['sub_action']]['is_selected'] = true;
	// Otherwise it's going to be the browse anyway...
	else
		$context['admin_tabs']['tabs']['main']['is_selected'] = true;

	$context['page_title'] = $txt['page_management'];
	// Call the right function.
	$subActions[$_REQUEST['sa']]();
}

function mainPages()
{
	global $context, $txt;

	$context['sub_template'] = 'main';
	$context['page_title'] 	 = $txt['page_management_title'];
}

function addPages()
{
	global $db_prefix, $context, $txt, $smcFunc;

	if(isset($_POST['add']))
	{
		$public = !empty($_POST['public']) ? 1 : 0;
		$enablephp = !empty($_POST['enablephp']) ? 1 : 0;
		$enablebbc = !empty($_POST['enablebbc']) ? 1 : 0;
		$showmenuitem = !empty($_POST['showmenuitem']) ? 1 : 0;

		$error = pages_check_content($_POST['content'], $enablephp, $enablebbc);
		if (!$error)
		{
			$cache_file = pages_put_cache(null, $_POST['content'], $enablephp, $enablebbc);
			if (!$cache_file)
				fatal_error($txt['page_management_error_caching'], false);

			$_POST['perms'][] = 1;

			for($i = 0; $i < count($_POST['perms']); $i++)
				$permissions[] = mysql_escape_string($_POST['perms'][$i]);

			$smcFunc['db_insert'](
				'insert',
				'{db_prefix}pages',
				array(
					'name' 							=> 'string',
					'content' 					=> 'string',
					'time' 							=> 'int',
					'publicate'					=> 'int',
					'showmenuitem'			=> 'int',
					'enablephp'					=> 'int',
					'enablebbc'					=> 'int',
					'permissions'				=> 'string',
					'req_posts'					=> 'int',
					'title'							=> 'string',
					'meta_keywords'			=> 'string',
					'meta_description' 	=> 'string',
				),
				array(
					trim($_POST['name']) === '' ? '-----' : $_POST['name'],
					$_POST['content'],
					time(),
					$public,
					$showmenuitem,
					$enablephp,
					$enablebbc,
					implode(',', $permissions),
					(int)$_POST['req_posts'],
					$_POST['title'],
					$_POST['meta_k'],
					$_POST['meta_d'],
				),
				array(
					'id',
				)
			);

			$page_id = $smcFunc['db_insert_id']('{db_prefix}pages', 'id');

			if (!rename($cache_file['filename'], str_replace($cache_file['hash'], $page_id, $cache_file['filename'])))
				fatal_error($txt['page_management_error_caching'], false);

			redirectexit('action=admin;area=pages;sa=main;msg=added');
		}
		else
		{
			$context['pages_error'] = $error;
		}
	}

	$context['sub_template'] 	= 'addPages';
	$context['page_title'] 		= $txt['page_management_add_title'];
}

function deletePages()
{
	global $db_prefix, $txt, $smcFunc;

	if(!isset($_REQUEST['page']) || !is_numeric($_REQUEST['page']))
		fatal_error($txt['page_management_error'], false);

	$smcFunc['db_query']('', "
		DELETE FROM `{db_prefix}pages`
		WHERE `id` = {int:id}",
		array(
			'id' => $_REQUEST['page'],
		)
	);

	@unlink(pages_get_cache_filename($_REQUEST['page']));

	redirectexit('action=admin;area=pages;sa=main;msg=deleted');
}

function publicPages()
{
	global $db_prefix, $txt, $smcFunc;

	if(!isset($_REQUEST['page']) || !is_numeric($_REQUEST['page']))
		fatal_error($txt['page_management_error'], false);

	$smcFunc['db_query']('', "
		UPDATE `{db_prefix}pages`
		SET `publicate` = 1
		WHERE `id` = {int:id}",
		array('id' => $_REQUEST['page'])
	);
	redirectexit('action=admin;area=pages;sa=main;');
}

function unpublicPages()
{
	global $db_prefix, $txt, $smcFunc;

	if(!isset($_REQUEST['page']) || !is_numeric($_REQUEST['page']))
		fatal_error($txt['page_management_error'], false);

	$smcFunc['db_query']('', "
		UPDATE `{db_prefix}pages`
		SET `publicate` = 0
		WHERE `id` = {int:id}",
		array('id' => $_REQUEST['page'])
	);
	redirectexit('action=admin;area=pages;sa=main');
}

function editPages()
{
	global $db_prefix, $context, $txt, $smcFunc;

	if(!isset($_REQUEST['page']) || !is_numeric($_REQUEST['page']))
		fatal_error($txt['page_management_error'], false);

	if(isset($_POST['save']))
	{
		$public 				= !empty($_POST['public']) ? 1 : 0;
		$enablephp 			= !empty($_POST['enablephp']) ? 1 : 0;
		$enablebbc 			= !empty($_POST['enablebbc']) ? 1 : 0;
		$showmenuitem 	= !empty($_POST['showmenuitem']) ? 1 : 0;

		$error = pages_check_content($_POST['content'], $enablephp, $enablebbc);
		if (!$error)
		{
			$cache_file = pages_put_cache($_REQUEST['page'], $_POST['content'], $enablephp, $enablebbc);
			if (!$cache_file)
				fatal_error($txt['page_management_error_caching'], false);

			$_POST['perms'][] = 1;

			for($i = 0; $i < count($_POST['perms']); $i++)
				$permissions[] = mysql_escape_string($_POST['perms'][$i]);

			$smcFunc['db_query']('', "
				UPDATE `{db_prefix}pages`
				SET
					`name` 							= {string:name},
					`content` 					= {string:content},
					`publicate` 				= {int:publicate},
					`showmenuitem` 			= {int:showmenuitem},
					`enablephp` 				= {int:enablephp},
					`enablebbc` 				= {int:enablebbc},
					`permissions` 			=	{string:permissions},
					`req_posts` 				= {int:req_posts},
					`title` 						= {string:title},
					`meta_keywords` 		= {string:meta_k},
					`meta_description` 	= {string:meta_d}
				WHERE
					`id` = {int:id}",
				array(
					'name' 							=> trim($_POST['name']) == '' ? '-----' : $_POST['name'],
					'content' 					=> $_POST['content'],
					'publicate'					=> $public,
					'showmenuitem'			=> $showmenuitem,
					'enablephp'					=> $enablephp,
					'enablebbc'					=> $enablebbc,
					'permissions'				=> implode(',', $permissions),
					'req_posts'					=> (int)$_POST['req_posts'],
					'title'							=> $_POST['title'],
					'meta_k'						=> $_POST['meta_k'],
					'meta_d'						=> $_POST['meta_d'],
					'id'								=> (int)$_REQUEST['page'],
				)
			);
			redirectexit('action=admin;area=pages;sa=main;msg=saved');
		}
	}

	$context['sub_template'] = 'editPages';
	$context['page_title'] = $txt['page_management_edit_title'];
}

function ShowPages()
{
	global $context, $pages, $db_prefix, $txt;

	if(!isset($_REQUEST['id']) || !is_numeric($_REQUEST['id']))
		redirectexit(null);

	loadTemplate('Pages');
	$context['page_title'] 		= $pages[$_REQUEST['id']]['title'];
	$context['meta_description'] 	= $pages[$_REQUEST['id']]['meta_d'];
	$context['meta_keywords'] 	= $pages[$_REQUEST['id']]['meta_k'];
	$context['sub_template'] 	= 'showPages';
}
?>